image: docker:stable

variables:
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_IMAGE_NAME: "$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG"
  POSTGRES_HOST: postgres
  POSTGRES_PORT: "5432"
  POSTGRES_USER: postgres
  POSTGRES_PASSWORD: test-pass
  POSTGRES_SCHEMA: public
  POSTGRES_DB: testdb
  HELM_NAME: "lkod"
  K8S_DEPLOYMENT_NAME: adminBackend
  K8S_DEPLOYMENT_IMAGE_TAG: $CI_PIPELINE_ID

stages:
  - build
  - release
  - deploy

include:
  - template: "Workflows/Branch-Pipelines.gitlab-ci.yml"
  - project: "operator-ict/devops/gitlab-ci-pipeline"
    file:
      - "/docker/simple-build.yml"
      - "/k8s-golemio/helm-golemio-deploy.yml"

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/

.run_tests:
  stage: build
  image: node:18.17.0-alpine
  services:
    - postgres:14.7
    - redis:7.2.1-alpine
  script:
    - npm install --progress=false
    - npm run lint
    # Audit production dependencies for HIGH vulnerabilities
    - npm audit --omit dev --audit-level high
    - npm run build
    - export LOG_LEVEL=INFO
    - export DB_HOSTNAME=$POSTGRES_HOST
    - export DB_PORT=$POSTGRES_PORT
    - export DB_DATABASE=$POSTGRES_DB
    - export DB_USERNAME=$POSTGRES_USER
    - export DB_PASSWORD=$POSTGRES_PASSWORD
    - export DB_SCHEMA=$POSTGRES_SCHEMA
    - export REDIS_CONN=redis://redis/
    - cat $PUBLIC_KEY > ./keys/key.pub
    - cat $PRIVATE_KEY > ./keys/key.key
    - npm run code-coverage
  rules:
    - when: always
  tags:
    - docker

# run_tests:
#     extends: .run_tests
#     image: node:18.14.0-alpine

# run_tests-node-next:
#      extends: .run_tests
#      image: node:19.6.0-alpine
#      allow_failure: true
